<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="110px">
      <el-form-item label="培训GUID" prop="ttsaTrainGuid">
        <el-input v-model="queryParams.ttsaTrainGuid" placeholder="请输入培训GUID" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="人员名称" prop="persName">
        <el-input v-model="queryParams.persName" placeholder="请输入人员名称" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="人员类型" prop="persType">
        <el-select v-model="queryParams.persType" placeholder="请选择人员类型" clearable>
          <el-option v-for="dict in ttsa_pers_type" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['ttsa:ttsatrainpers:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate" v-hasPermi="['ttsa:ttsatrainpers:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete" v-hasPermi="['ttsa:ttsatrainpers:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['ttsa:ttsatrainpers:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList" :columns="columns" storageKey="ttsa-ttsatrainpers-index"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="dataList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="人员名称" prop="persName" />
      <el-table-column label="人员类型" prop="persType" width="120">
        <template #default="scope">
          <dict-tag :options="ttsa_pers_type" :value="scope.row.persType" />
        </template>
      </el-table-column>
      <el-table-column label="证书GUID" prop="ttsaCertGuid" />
      <el-table-column label="培训GUID" prop="ttsaTrainGuid" />
      <el-table-column label="培训结果" prop="trainResu" />
      <el-table-column label="操作" align="center" width="200">
        <template #default="scope">
          <el-tooltip content="修改" placement="top">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['ttsa:ttsatrainpers:edit']"></el-button>
          </el-tooltip>
          <el-tooltip content="删除" placement="top">
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['ttsa:ttsatrainpers:remove']"></el-button>
          </el-tooltip>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />

    <el-dialog :title="title" v-model="open" width="600px" append-to-body>
      <el-form ref="formRef" :model="form" :rules="rules" label-width="110px">
        <el-form-item label="证书GUID" prop="ttsaCertGuid">
          <el-input v-model="form.ttsaCertGuid" placeholder="请输入证书GUID" />
        </el-form-item>
        <el-form-item label="人员名称" prop="persName">
          <el-input v-model="form.persName" placeholder="请输入人员名称" />
        </el-form-item>
        <el-form-item label="人员类型" prop="persType">
          <el-select v-model="form.persType" placeholder="请选择人员类型">
            <el-option v-for="dict in ttsa_pers_type" :key="dict.value" :label="dict.label" :value="dict.value" />
          </el-select>
        </el-form-item>
        <el-form-item label="培训GUID" prop="ttsaTrainGuid">
          <el-input v-model="form.ttsaTrainGuid" placeholder="请输入培训GUID" />
        </el-form-item>
        <el-form-item label="培训结果" prop="trainResu">
          <el-input v-model="form.trainResu" placeholder="请输入培训结果" />
        </el-form-item>
        <el-form-item label="备注" prop="note">
          <el-input v-model="form.note" type="textarea" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="TtsaTrainPers">
import { listBisTtsaTrainPers, getBisTtsaTrainPers, addBisTtsaTrainPers, updateBisTtsaTrainPers, delBisTtsaTrainPers } from "@/api/slaj/ttsa";
import { getCurrentInstance, reactive, ref, toRefs } from "vue";

const { proxy } = getCurrentInstance();
const { ttsa_pers_type } = proxy.useDict("ttsa_pers_type");

const dataList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");
const columns = ref({ persName: { visible: true }, persType: { visible: true }, ttsaCertGuid: { visible: true }, ttsaTrainGuid: { visible: true }, trainResu: { visible: true } });

const data = reactive({
  form: {},
  queryParams: { pageNum: 1, pageSize: 10, ttsaTrainGuid: null, persName: null, persType: null },
  rules: {}
});
const { form, queryParams, rules } = toRefs(data);

function getList() {
  loading.value = true;
  listBisTtsaTrainPers(queryParams.value).then(r => {
    dataList.value = r.rows;
    total.value = r.total;
    loading.value = false;
  });
}

function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

function handleSelectionChange(s) {
  ids.value = s.map(i => i.guid);
  single.value = s.length !== 1;
  multiple.value = !s.length;
}

function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加培训人员";
}

function handleUpdate(row) {
  reset();
  getBisTtsaTrainPers(row.guid || ids.value[0]).then(r => {
    form.value = r.data;
    open.value = true;
    title.value = "修改培训人员";
  });
}

function submitForm() {
  proxy.$refs["formRef"].validate(v => {
    if (v) {
      if (form.value.guid != null) {
        updateBisTtsaTrainPers(form.value).then(() => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addBisTtsaTrainPers(form.value).then(() => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

function handleDelete(row) {
  proxy.$modal.confirm('确认删除？').then(() => delBisTtsaTrainPers(row.guid || ids.value.join(","))).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  });
}

function handleExport() {
  proxy.download('/ttsa/ttsatrainpers/export', { ...queryParams.value }, `培训人员_${new Date().getTime()}.xlsx`);
}

function cancel() {
  open.value = false;
  reset();
}

function reset() {
  form.value = { guid: null, ttsaCertGuid: null, persName: null, persType: null, ttsaTrainGuid: null, trainResu: null, note: null };
  proxy.resetForm("formRef");
}

getList();
</script>
